OpenVDB: NodeMask< 1 > Class Template Reference

OpenVDB 3.1.0

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
NodeMask< 1 > Class Template Reference

Template specialization of NodeMask for Log2Dim=1, i.e. 2^3 nodes. More...

`#include <NodeMasks.h>`

## Public Types
typedef Byte | Word
typedef OnMaskIterator< NodeMask > | OnIterator
typedef OffMaskIterator< NodeMask > | OffIterator
typedef DenseMaskIterator< NodeMask > | DenseIterator

## Public Member Functions
| NodeMask ()
| Default constructor sets all bits off. More...
| NodeMask (bool on)
| All bits are set to the specified state. More...
| NodeMask (const NodeMask &other)
| Copy constructor. More...
| ~NodeMask ()
| Destructor. More...
void | operator= (const NodeMask &other)
| Assignment operator. More...
OnIterator | beginOn () const
OnIterator | endOn () const
OffIterator | beginOff () const
OffIterator | endOff () const
DenseIterator | beginDense () const
DenseIterator | endDense () const
bool | operator== (const NodeMask &other) const
bool | operator!= (const NodeMask &other) const
template<typename WordOp >
const NodeMask & | foreach (const NodeMask &other, const WordOp &op)
| Apply a functor to the words of the this and the other mask. More...
template<typename WordOp >
const NodeMask & | foreach (const NodeMask &other1, const NodeMask &other2, const WordOp &op)
template<typename WordOp >
const NodeMask & | foreach (const NodeMask &other1, const NodeMask &other2, const NodeMask &other3, const WordOp &op)
const NodeMask & | operator&= (const NodeMask &other)
| Bitwise intersection. More...
const NodeMask & | operator|= (const NodeMask &other)
| Bitwise union. More...
const NodeMask & | operator-= (const NodeMask &other)
| Bitwise difference. More...
const NodeMask & | operator^= (const NodeMask &other)
| Bitwise XOR. More...
NodeMask | operator! () const
NodeMask | operator& (const NodeMask &other) const
NodeMask | operator| (const NodeMask &other) const
NodeMask | operator^ (const NodeMask &other) const
Index32 | countOn () const
| Return the total number of on bits. More...
Index32 | countOff () const
| Return the total number of on bits. More...
void | setOn (Index32 n)
| Set the nth bit on. More...
void | setOff (Index32 n)
| Set the nth bit off. More...
void | set (Index32 n, bool On)
| Set the nth bit to the specified state. More...
void | set (bool on)
| Set all bits to the specified state. More...
void | setOn ()
| Set all bits on. More...
void | setOff ()
| Set all bits off. More...
void | toggle (Index32 n)
| Toggle the state of the nth bit. More...
void | toggle ()
| Toggle the state of all bits in the mask. More...
void | setFirstOn ()
| Set the first bit on. More...
void | setLastOn ()
| Set the last bit on. More...
void | setFirstOff ()
| Set the first bit off. More...
void | setLastOff ()
| Set the last bit off. More...
bool | isOn (Index32 n) const
| Return true if the nth bit is on. More...
bool | isOff (Index32 n) const
| Return true if the nth bit is off. More...
bool | isOn () const
| Return true if all the bits are on. More...
bool | isOff () const
| Return true if all the bits are off. More...
Index32 | findFirstOn () const
Index32 | findFirstOff () const
void | save (std::ostream &os) const
void | load (std::istream &is)
void | printInfo (std::ostream &os=std::cout) const
| simple print method for debugging More...
void | printBits (std::ostream &os=std::cout) const
void | printAll (std::ostream &os=std::cout) const
Index32 | findNextOn (Index32 start) const
Index32 | findNextOff (Index32 start) const

## Static Public Member Functions
static Index32 | memUsage ()
| Return the byte size of this NodeMask. More...

## Static Public Attributes
static const Index32 | LOG2DIM = 1
static const Index32 | DIM = 2
static const Index32 | SIZE = 8
static const Index32 | WORD_COUNT = 1

## Detailed Description

### template<>
class openvdb::v3_1_0::util::NodeMask< 1 >

Template specialization of NodeMask for Log2Dim=1, i.e. 2^3 nodes.

## Member Typedef Documentation

typedef DenseMaskIterator<NodeMask> DenseIterator

typedef OffMaskIterator<NodeMask> OffIterator

typedef OnMaskIterator<NodeMask> OnIterator

typedef Byte Word

## Constructor & Destructor Documentation

NodeMask | ( |  | ) |
| inline

Default constructor sets all bits off.

NodeMask | ( | bool | on | ) |
| inline

All bits are set to the specified state.

NodeMask | ( | const NodeMask< 1 > & | other | ) |
| inline

Copy constructor.

~NodeMask | ( |  | ) |
| inline

Destructor.

## Member Function Documentation

DenseIterator beginDense | ( |  | ) | const
| inline

OffIterator beginOff | ( |  | ) | const
| inline

OnIterator beginOn | ( |  | ) | const
| inline

Index32 countOff | ( |  | ) | const
| inline

Return the total number of on bits.

Index32 countOn | ( |  | ) | const
| inline

Return the total number of on bits.

DenseIterator endDense | ( |  | ) | const
| inline

OffIterator endOff | ( |  | ) | const
| inline

OnIterator endOn | ( |  | ) | const
| inline

Index32 findFirstOff | ( |  | ) | const
| inline

Index32 findFirstOn | ( |  | ) | const
| inline

Index32 findNextOff | ( | Index32 | start | ) | const
| inline

Index32 findNextOn | ( | Index32 | start | ) | const
| inline

const NodeMask& foreach | ( | const NodeMask< 1 > & | other,
|  | const WordOp & | op
| ) |  |
| inline

Apply a functor to the words of the this and the other mask.

An example that implements the "operator&=" method:

struct Op { inline void operator()(Word &w1, const Word& w2) const { w1 &= w2; } };

const NodeMask& foreach | ( | const NodeMask< 1 > & | other1,
|  | const NodeMask< 1 > & | other2,
|  | const WordOp & | op
| ) |  |
| inline

const NodeMask& foreach | ( | const NodeMask< 1 > & | other1,
|  | const NodeMask< 1 > & | other2,
|  | const NodeMask< 1 > & | other3,
|  | const WordOp & | op
| ) |  |
| inline

bool isOff | ( | Index32 | n | ) | const
| inline

Return true if the nth bit is off.

bool isOff | ( |  | ) | const
| inline

Return true if all the bits are off.

bool isOn | ( | Index32 | n | ) | const
| inline

Return true if the nth bit is on.

bool isOn | ( |  | ) | const
| inline

Return true if all the bits are on.

void load | ( | std::istream & | is | ) |
| inline

static Index32 memUsage | ( |  | ) |
| inlinestatic

Return the byte size of this NodeMask.

NodeMask operator! | ( |  | ) | const
| inline

bool operator!= | ( | const NodeMask< 1 > & | other | ) | const
| inline

NodeMask operator& | ( | const NodeMask< 1 > & | other | ) | const
| inline

const NodeMask& operator&= | ( | const NodeMask< 1 > & | other | ) |
| inline

Bitwise intersection.

const NodeMask& operator-= | ( | const NodeMask< 1 > & | other | ) |
| inline

Bitwise difference.

void operator= | ( | const NodeMask< 1 > & | other | ) |
| inline

Assignment operator.

bool operator== | ( | const NodeMask< 1 > & | other | ) | const
| inline

NodeMask operator^ | ( | const NodeMask< 1 > & | other | ) | const
| inline

const NodeMask& operator^= | ( | const NodeMask< 1 > & | other | ) |
| inline

Bitwise XOR.

NodeMask operator| | ( | const NodeMask< 1 > & | other | ) | const
| inline

const NodeMask& operator|= | ( | const NodeMask< 1 > & | other | ) |
| inline

Bitwise union.

void printAll | ( | std::ostream & | os = `std::cout` | ) | const
| inline

void printBits | ( | std::ostream & | os = `std::cout` | ) | const
| inline

void printInfo | ( | std::ostream & | os = `std::cout` | ) | const
| inline

simple print method for debugging

void save | ( | std::ostream & | os | ) | const
| inline

void set | ( | Index32 | n,
|  | bool | On
| ) |  |
| inline

Set the nth bit to the specified state.

void set | ( | bool | on | ) |
| inline

Set all bits to the specified state.

void setFirstOff | ( |  | ) |
| inline

Set the first bit off.

void setFirstOn | ( |  | ) |
| inline

Set the first bit on.

void setLastOff | ( |  | ) |
| inline

Set the last bit off.

void setLastOn | ( |  | ) |
| inline

Set the last bit on.

void setOff | ( | Index32 | n | ) |
| inline

Set the nth bit off.

void setOff | ( |  | ) |
| inline

Set all bits off.

void setOn | ( | Index32 | n | ) |
| inline

Set the nth bit on.

void setOn | ( |  | ) |
| inline

Set all bits on.

void toggle | ( | Index32 | n | ) |
| inline

Toggle the state of the nth bit.

void toggle | ( |  | ) |
| inline

Toggle the state of all bits in the mask.

## Member Data Documentation

const Index32 DIM = 2
| static

const Index32 LOG2DIM = 1
| static

const Index32 SIZE = 8
| static

const Index32 WORD_COUNT = 1
| static

The documentation for this class was generated from the following file:

- NodeMasks.h